%{
#include "declarations.h"
#include "heap.h"


typedef struct
  {
  int        numargs;
  _HeapAddr  args[50];
  } _AtribListTerms;

_Ident       VarTable[200];
int          numvars;


short int VarTableCheckVar(_Ident name)
Proc
Var
  short int i;
EndVar
  i=0;
  While i<numvars Do
    If strcmp( VarTable[i], name)==0 Then
      Return(i);
    Else
      i++;
    EndIf
  EndWhile
  strcpy(VarTable[i], name);
  numvars++;
  Return(i);
EndProc



%}

%union{ 
        _Ident           ident;
        _HeapAddr        heapaddr;
        _AtribListTerms  atriblist;
        int              arity
      }

%token NOT POS EQ SIG SLASH
%token <ident>     SYMBOL
%token <ident>     VAR

%type <heapaddr>     term
%type <atriblist>    listterms

%start leqs

%%

leqs
  :
    SIG '(' list_symbols ')' '.' leqs
  |
    POS
        { numvars = 0; }
    term EQ term
        { inputLeftTerms[numterms]=$3; inputRightTerms[numterms++]=$5; }
    '.'
    leqs
  |     { numvars = 0; }
    term EQ term
        { inputLeftTerms[numterms]=$2; inputRightTerms[numterms++]=$4; }
    '.'
    leqs
  |
    NOT
        { numvars = 0; }
    term EQ term
        { inputLeftTerms[0]=$3; inputRightTerms[0]=$5; }
    '.'
    leqs
  |
  ;

list_symbols
  :
    SYMBOL SLASH SYMBOL
      { int s;
        If !strcmp( $3, "ac" ) Then 
          s=STCheckSymbol($1,2); 
          STSetAC(s); 
        Else
          STCheckSymbol($1,atoi($3)); 
        EndIf
      }
  |
    list_symbols ','
    SYMBOL SLASH SYMBOL
      { int s;
        If !strcmp( $5, "ac" ) Then 
          s=STCheckSymbol($3,2); 
          STSetAC(s); 
        Else
          STCheckSymbol($3,atoi($5)); 
        EndIf
      }
  ;

term
  : SYMBOL
        { $$ = HeapCreateStruct( STCheckSymbol($1,0) ); }
  |
    VAR
        { $$ = VBHeapAddr( bankDemod, VarTableCheckVar($1)); }
  |
    SYMBOL
    '('    
    listterms
    ')'
        { int i; 
          $$ = HeapCreateStruct( STCheckSymbol($1,($3.numargs)) );
          For i=1;i<=($3.numargs);i++ Do
            HeapSetAddr( HeapIthArg($$,i), ($3.args)[i]);
          EndFor
        }
  |
    '('
    term
    SYMBOL
    term
    ')'
        {
          $$ = HeapCreateStruct( STCheckSymbol($3,2) );
          HeapSetAddr( HeapIthArg($$,1),$2);
          HeapSetAddr( HeapIthArg($$,2),$4);
        }
  ;


listterms
  : listterms
    ','
    term
        { ($1.numargs)++; ($1.args)[$1.numargs]=$3; $$ = $1; }
  |
    term
        { $$.numargs=1; ($$.args)[1]=$1; }
  ;

%%
#include "lex.yy.c"
void yyerror(s) char *s;
{
  fprintf(stderr, "%s\n", s);
}


